package com.yilesoft.app.textimage.moveedit;

import android.graphics.Paint;
import android.graphics.Path;




import java.io.Serializable;
import java.util.List;

public class EditFrameInfo implements Serializable {
    private static final long serialVersionUID = -4881164823076690003L;

    public static final int TYPE_PICTURE = 1;
    public static final int TYPE_TEXT = 2;
    public static final int TYPE_ICON = 3;
    public static final int TYPE_ARROW = 4;
    public static final int TYPE_LINE = 5;
    public static final int TYPE_CIRCLE = 6;

    /**
     * 一个编辑框包含以下属性
     */
    //控件X坐标
    private int mRawX;
    //控件Y坐标
    private int mRawY;
    //控件宽
    private int mWidth;
    //控件高
    private int mHeight;
    //ArrowView初始坐标
    private float mStartX,mStartY;
    //ArrowView终点坐标
    private float mEndX,mEndY;

    //控件类型（文本、图片） 4 箭头 5 直线
    private int mViewType;
    //图片本地地址/图标ID
    private String mLocalImgPath;
    private int mLocalImgId;
    private String mUrlImagePath;
    private String mLocalImgBitmap;//本地图片bitmap
    //以下为文本当前属性:内容、颜色、字体大小、粗细、内边距值及编辑框背景本地路径
    private String mContent;
    private int mTextColor;
    private float mTextSize;//存的是sp！！！！！！！！！！！！
    private float mTotalTextSize;//富文本整体大小 存的是sp！！！！！！！！！！！！
    private int mLastTotalStyle;
    private BubbleInfo mBubbleInfo;
    private String eidtBg;
    private int textType;
    //circleView
    private Path mPath;
    private Paint mPaint;
   // private CircleInfo circleInfo;
    //富文本
    private SpansInfo sizeInfo;
    private SpansInfo colorInfo;
    private SpansInfo styleInfo;
    private List<SpansInfo> spansInfoList;//现在用这个
    //双指旋转缩放
    private float transX = 0;//总X轴偏移量
    private float transY = 0;//总Y轴偏移量
    private float scaleX = 1;//x轴缩放比
    private float scaleY = 1;//y轴缩放比
    private float rotation = 0;//总旋转角

    private int locationX;
    private int locationY;

    //MoveLayout四个缩放角的宽高
    private int cornerWidth = 0;
    private int cornerHeight = 0;

    private int versionCode = 0;//定义见CustomsEditText同名属性
    private Effects effects;

    private TextTypeBean textTypeBean;

    public int getmRawX() {
        return mRawX;
    }

    public void setmRawX(int mRawX) {
        this.mRawX = mRawX;
    }

    public int getmRawY() {
        return mRawY;
    }

    public void setmRawY(int mRawY) {
        this.mRawY = mRawY;
    }

    public int getmWidth() {
        return mWidth;
    }

    public void setmWidth(int mWidth) {
        this.mWidth = mWidth;
    }

    public int getmHeight() {
        return mHeight;
    }

    public void setmHeight(int mHeight) {
        this.mHeight = mHeight;
    }

    public int getmViewType() {
        return mViewType;
    }

    public void setmViewType(int mViewType) {
        this.mViewType = mViewType;
    }

    public String getmContent() {
        return mContent;
    }

    public void setmContent(String mContent) {
        this.mContent = mContent;
    }

    public String getmLocalImgPath() {
        return mLocalImgPath;
    }

    public void setmLocalImgPath(String mLocalImgPath) {
        this.mLocalImgPath = mLocalImgPath;
    }

    public int getmLocalImgId() {
        return mLocalImgId;
    }

    public void setmLocalImgId(int mLocalImgId) {
        this.mLocalImgId = mLocalImgId;
    }

    public String getmUrlImagePath() {
        return mUrlImagePath;
    }

    public void setmUrlImagePath(String mUrlImagePath) {
        this.mUrlImagePath = mUrlImagePath;
    }

    public int getmTextColor() {
        return mTextColor;
    }

    public void setmTextColor(int mTextColor) {
        this.mTextColor = mTextColor;
    }

    public float getmTextSize() {
        return mTextSize;
    }

    public void setmTextSize(float mTextSize) {
        this.mTextSize = mTextSize;
    }


    public BubbleInfo getmBubbleInfo() {
        return mBubbleInfo;
    }

    public void setmBubbleInfo(BubbleInfo mBubbleInfo) {
        this.mBubbleInfo = mBubbleInfo;
    }

    public String getEidtBg() {
        return eidtBg;
    }

    public void setEidtBg(String eidtBg) {
        this.eidtBg = eidtBg;
    }

    public int getTextType() {
        return textType;
    }

    public void setTextType(int textType) {
        this.textType = textType;
    }

    public float getmStartX() {
        return mStartX;
    }

    public void setmStartX(float mStartX) {
        this.mStartX = mStartX;
    }

    public float getmStartY() {
        return mStartY;
    }

    public void setmStartY(float mStartY) {
        this.mStartY = mStartY;
    }

    public float getmEndX() {
        return mEndX;
    }

    public void setmEndX(float mEndX) {
        this.mEndX = mEndX;
    }

    public float getmEndY() {
        return mEndY;
    }

    public void setmEndY(float mEndY) {
        this.mEndY = mEndY;
    }

    public String getmLocalImgBitmap() {
        return mLocalImgBitmap;
    }

    public void setmLocalImgBitmap(String mLocalImgBitmap) {
        this.mLocalImgBitmap = mLocalImgBitmap;
    }

    public Path getmPath() {
        return mPath;
    }

    public void setmPath(Path mPath) {
        this.mPath = mPath;
    }

    public Paint getmPaint() {
        return mPaint;
    }

    public void setmPaint(Paint mPaint) {
        this.mPaint = mPaint;
    }

    public SpansInfo getSizeInfo() {
        return sizeInfo;
    }

    public void setSizeInfo(SpansInfo sizeInfo) {
        this.sizeInfo = sizeInfo;
    }

    public SpansInfo getColorInfo() {
        return colorInfo;
    }

    public void setColorInfo(SpansInfo colorInfo) {
        this.colorInfo = colorInfo;
    }

    public SpansInfo getStyleInfo() {
        return styleInfo;
    }

    public void setStyleInfo(SpansInfo styleInfo) {
        this.styleInfo = styleInfo;
    }

//    public CircleInfo getCircleInfo() {
//        return circleInfo;
//    }
//
//    public void setCircleInfo(CircleInfo circleInfo) {
//        this.circleInfo = circleInfo;
//    }


    public float getTransX() {
        return transX;
    }

    public void setTransX(float transX) {
        this.transX = transX;
    }

    public float getTransY() {
        return transY;
    }

    public void setTransY(float transY) {
        this.transY = transY;
    }

    public float getScaleX() {
        return scaleX;
    }

    public void setScaleX(float scaleX) {
        this.scaleX = scaleX;
    }

    public float getScaleY() {
        return scaleY;
    }

    public void setScaleY(float scaleY) {
        this.scaleY = scaleY;
    }

    public float getRotation() {
        return rotation;
    }

    public void setRotation(float rotation) {
        this.rotation = rotation;
    }

    public List<SpansInfo> getSpansInfoList() {
        return spansInfoList;
    }

    public void setSpansInfoList(List<SpansInfo> spansInfoList) {
        this.spansInfoList = spansInfoList;
    }

    public int getLocationX() {
        return locationX;
    }

    public void setLocationX(int locationX) {
        this.locationX = locationX;
    }

    public int getLocationY() {
        return locationY;
    }

    public void setLocationY(int locationY) {
        this.locationY = locationY;
    }

    public float getmTotalTextSize() {
        return mTotalTextSize;
    }

    public void setmTotalTextSize(float mTotalTextSize) {
        this.mTotalTextSize = mTotalTextSize;
    }

    public int getmLastTotalStyle() {
        return mLastTotalStyle;
    }

    public void setmLastTotalStyle(int mLastTotalStyle) {
        this.mLastTotalStyle = mLastTotalStyle;
    }

    public int getCornerWidth() {
        return cornerWidth;
    }

    public void setCornerWidth(int cornerWidth) {
        this.cornerWidth = cornerWidth;
    }

    public int getCornerHeight() {
        return cornerHeight;
    }

    public void setCornerHeight(int cornerHeight) {
        this.cornerHeight = cornerHeight;
    }

    public TextTypeBean getTextTypeBean() {
        return textTypeBean;
    }

    public void setTextTypeBean(TextTypeBean textTypeBean) {
        this.textTypeBean = textTypeBean;
    }

    public int getVersionCode() {
        return versionCode;
    }

    public void setVersionCode(int versionCode) {
        this.versionCode = versionCode;
    }

    public Effects getEffects() {
        return effects;
    }

    public void setEffects(Effects effects) {
        this.effects = effects;
    }

    @Override
    public String toString() {
        return "EditFrameInfo{" +
                "mRawX=" + mRawX +
                ", mRawY=" + mRawY +
                ", mWidth=" + mWidth +
                ", mHeight=" + mHeight +
                ", mStartX=" + mStartX +
                ", mStartY=" + mStartY +
                ", mEndX=" + mEndX +
                ", mEndY=" + mEndY +
                ", mViewType=" + mViewType +
                ", mLocalImgPath='" + mLocalImgPath + '\'' +
                ", mLocalImgId=" + mLocalImgId +
                ", mUrlImagePath='" + mUrlImagePath + '\'' +
                ", mLocalImgBitmap='" + mLocalImgBitmap + '\'' +
                ", mContent='" + mContent + '\'' +
                ", mTextColor=" + mTextColor +
                ", mTextSize=" + mTextSize +
                ", mTotalTextSize=" + mTotalTextSize +
                ", mLastTotalStyle=" + mLastTotalStyle +
                ", mBubbleInfo=" + mBubbleInfo +
                ", eidtBg='" + eidtBg + '\'' +
                ", textType=" + textType +
                ", mPath=" + mPath +
                ", mPaint=" + mPaint +
               // ", circleInfo=" + circleInfo +
                ", sizeInfo=" + sizeInfo +
                ", colorInfo=" + colorInfo +
                ", styleInfo=" + styleInfo +
                ", spansInfoList=" + spansInfoList +
                ", transX=" + transX +
                ", transY=" + transY +
                ", scaleX=" + scaleX +
                ", scaleY=" + scaleY +
                ", rotation=" + rotation +
                ", locationX=" + locationX +
                ", locationY=" + locationY +
                ", cornerWidth=" + cornerWidth +
                ", cornerHeight=" + cornerHeight +
                ", versionCode=" + versionCode +
                ", effects=" + effects +
                ", textTypeBean=" + textTypeBean +
                '}';
    }
}

