package com.yilesoft.app.textimage.moveedit;

import android.app.Activity;
import android.content.Context;
import android.content.pm.PackageManager;
import android.content.res.Resources;
import android.graphics.Color;
import android.graphics.Rect;
import android.graphics.Typeface;
import android.os.Build;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.TextUtils;
import android.text.style.AbsoluteSizeSpan;
import android.text.style.BackgroundColorSpan;
import android.text.style.ForegroundColorSpan;
import android.text.style.StrikethroughSpan;
import android.text.style.StyleSpan;
import android.text.style.UnderlineSpan;
import android.util.DisplayMetrics;
import android.view.Gravity;
import android.widget.TextView;
import android.widget.Toast;


import com.just.wholewriter.json.Constant;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import okhttp3.MultipartBody;
import okhttp3.RequestBody;

//通用工具类
public class Utils {

    private static final String TAG = Utils.class.getSimpleName();

    /**
     * @return 填充了接口需要的通用参数之后的map--user_id/timestamp/token
     */
//    public static Map<String, RequestBody> getNormalRequestBodyMap() {
//        int mills = getCurrentTimeMills();
//        Map<String, RequestBody> map = new HashMap<>();
//        map.put("user_id", MultipartBody.create(MultipartBody.FORM, SharedPreferencesUtil.getIntDate(Constant.SPKEY_USERID)+""));
//        LogUtil.i(TAG + " userId = " + SharedPreferencesUtil.getIntDate(Constant.SPKEY_USERID));
//        map.put("timestamp", MultipartBody.create(MultipartBody.FORM, mills + ""));
//        map.put("token", MultipartBody.create(MultipartBody.FORM, MD5Utils.md5(SharedPreferencesUtil.getIntDate(Constant.SPKEY_USERID) + "" + mills + Constant.KEY)));
//        return map;
//    }

//    /**
//     * @param keys   参数名数组
//     * @param values 参数值数组
//     * @return 填充了提供的参数+通用三个参数的map
//     */
//    public static Map<String, RequestBody> getCustomRequestBodyMap(String[] keys, String[] values) {
//        Map<String, RequestBody> map = getNormalRequestBodyMap();
//        for (int i = 0; i < keys.length; i++) {
//            map.put(keys[i], MultipartBody.create(MultipartBody.FORM, values[i]));
//        }
//        return map;
//    }

    /**
     * 校验手机号输入
     *
     * @param mobileNums 手机号
     */
    public static boolean isMobileNO(String mobileNums) {
        String telRegex = "^((13[0-9])|(14[5,7,9])|(15[^4])|(16[0-9])|(18[0-9])|(17[0,1,3,5,6,7,8]))\\d{8}$";
        if (TextUtils.isEmpty(mobileNums))
            return false;
        else
            return mobileNums.matches(telRegex);
    }

    //获取当前时间戳 单位 ： 秒
    public static int getCurrentTimeMills() {
        return (int) (System.currentTimeMillis() / 1000);
    }

    //判断列表是否为空
    public static boolean isListEmpty(List list) {
        if (list != null && list.size() > 0) {
            return false;
        }
        return true;
    }

//    /**
//     * 根据url获取文件名 /material/bubble/drawable-hdpi/ic_bubble1.png
//     *
//     * @param type 无效参数，随便传
//     * @param size Constant.SIZE_LARGE SIZE_XXX
//     * @param url  图片网络链接
//     * @return 文件绝对路径
//     */
//    public static String getResourceFileName(String type, String size, String url) {
//        String[] pieces = url.split("/");
//        String name = pieces[pieces.length - 1];
//        String basePath = Constant.RESOURCES_MATERIAL_DOWNLOAD_FOLDER;
//        String filePath = "";
//        switch (size) {
//            case Constant.SIZE_SMALL:
//                filePath = basePath + Constant.SIZE_SMALL + "/" + name;
//                break;
//            case Constant.SIZE_MIDDLE:
//                filePath = basePath + Constant.SIZE_MIDDLE + "/" + name;
//                break;
//            case Constant.SIZE_LARGE:
//                filePath = basePath + Constant.SIZE_LARGE + "/" + name;
//                break;
//        }
//        return filePath;
//    }

    public static String getResourceFileName(String dirPath, String url) {
        String[] pieces = url.split("/");
        String name = pieces[pieces.length - 1];
        return dirPath + name;
    }

//    /**
//     * Check if this device has a camera
//     *
//     * @param context
//     * @return
//     */
//    public static boolean checkCameraHardware(Context context) {
//        if (context != null && context.getPackageManager().hasSystemFeature(PackageManager.FEATURE_CAMERA)) {
//            // this device has a camera
//            return true;
//        } else {
//            // no camera on this device
//            return false;
//        }
//    }

    public static DisplayMetrics getScreenWH(Context context) {
        DisplayMetrics dMetrics = new DisplayMetrics();
        dMetrics = context.getResources().getDisplayMetrics();
        return dMetrics;
    }

    /**
     * count focus and metering region
     *
     * @param focusWidth
     * @param focusHeight
     * @param areaMultiple
     * @param x
     * @param y
     * @param previewleft
     * @param previewRight
     * @param previewTop
     * @param previewBottom
     * @return Rect(left, top, right, bottom)
     */
    public static Rect calculateTapArea(int focusWidth, int focusHeight,
                                        float areaMultiple, float x, float y, int previewleft,
                                        int previewRight, int previewTop, int previewBottom) {
        int areaWidth = (int) (focusWidth * areaMultiple);
        int areaHeight = (int) (focusHeight * areaMultiple);
        int centerX = (previewleft + previewRight) / 2;
        int centerY = (previewTop + previewBottom) / 2;
        double unitx = ((double) previewRight - (double) previewleft) / 2000;
        double unity = ((double) previewBottom - (double) previewTop) / 2000;
        int left = clamp((int) (((x - areaWidth / 2) - centerX) / unitx),
                -1000, 1000);
        int top = clamp((int) (((y - areaHeight / 2) - centerY) / unity),
                -1000, 1000);
        int right = clamp((int) (left + areaWidth / unitx), -1000, 1000);
        int bottom = clamp((int) (top + areaHeight / unity), -1000, 1000);

        return new Rect(left, top, right, bottom);
    }

    public static int clamp(int x, int min, int max) {
        if (x > max)
            return max;
        if (x < min)
            return min;
        return x;
    }

    public static final int getWidthInPx(Context context) {
        final int width = context.getResources().getDisplayMetrics().widthPixels;
        return width;
    }

    public static final int getHeightInPx(Context context) {
        final int height = context.getResources().getDisplayMetrics().heightPixels;
        return height;
    }

    public static void loadSpans(EditFrameInfo frameInfo, TextView textView) {
        if (TextUtils.isEmpty(textView.getText()) || Utils.isListEmpty(frameInfo.getSpansInfoList())) {
            LogUtil.e(TAG + " loadSpansInfo : editableText is null");
            return;
        }

        SpannableString ss = new SpannableString(textView.getText());
        for (int i = 0; i < textView.getText().length(); i++) {
            int spansInfoSize = frameInfo.getSpansInfoList().size();
            if(spansInfoSize <= i){
                LogUtil.e(TAG+" !!!!!loadSpans error : spansInfoSize <= index!!!!");
                break;
            }
            SpansInfo tempSpans = frameInfo.getSpansInfoList().get(i);
            Map<Integer, Integer> spansMap = tempSpans.getSpansInfoMap();
            for (Integer key : spansMap.keySet()) {
                switch (key) {
                    case CustomsEditText.TEXT_SIZE:
                        AbsoluteSizeSpan sizeSpan = new AbsoluteSizeSpan(spansMap.get(key));
                        ss.setSpan(sizeSpan, i, i + 1, Spanned.SPAN_INCLUSIVE_EXCLUSIVE);
                        break;
                    case CustomsEditText.TEXT_COLOR:
                        ForegroundColorSpan colorSpan = new ForegroundColorSpan(spansMap.get(key));
                        ss.setSpan(colorSpan, i, i + 1, Spanned.SPAN_INCLUSIVE_EXCLUSIVE);
                        break;
                    case CustomsEditText.TEXT_STYLE:
                        StyleSpan styleSpan = new StyleSpan(spansMap.get(key));
                        ss.setSpan(styleSpan, i, i + 1, Spanned.SPAN_INCLUSIVE_EXCLUSIVE);
                        break;
                }
            }
        }
        textView.setText(ss);
    }

    /**
     * 将系统表情转化为字符串
     *
     * @param s
     * @return
     */
    public static String getString(String s) {
        int length = s.length();
        String context = "";
        //循环遍历字符串，将字符串拆分为一个一个字符
        for (int i = 0; i < length; i++) {
            char codePoint = s.charAt(i);
            //判断字符是否是emoji表情的字符
            if (isEmojiCharacter(codePoint)) {
                //如果是将以大括号括起来
                String emoji = "{" + Integer.toHexString(codePoint) + "}";
                context = context + emoji;
                continue;
            }
            context = context + codePoint;
        }
        return context;
    }

    /**
     * 是否包含表情
     *
     * @param codePoint
     * @return 如果不包含 返回false,包含 则返回true
     */

    private static boolean isEmojiCharacter(char codePoint) {
        return !((codePoint == 0x0) || (codePoint == 0x9) || (codePoint == 0xA)
                || (codePoint == 0xD)
                || ((codePoint >= 0x20) && (codePoint <= 0xD7FF))
                || ((codePoint >= 0xE000) && (codePoint <= 0xFFFD)) || ((codePoint >= 0x10000) && (codePoint <= 0x10FFFF)));
    }

    /**
     * 将表情描述转换成表情
     *
     * @param str
     * @return
     */
    public static String getEmoji(String str) {
        String string = str;
        String rep = "\\{(.*?)\\}";
        Pattern p = Pattern.compile(rep);
        Matcher m = p.matcher(string);
        while (m.find()) {
            String s1 = m.group().toString();
            String s2 = s1.substring(1, s1.length() - 1);
            String s3;
            try {
                s3 = String.valueOf((char) Integer.parseInt(s2, 16));
                string = string.replace(s1, s3);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return string;
    }

//    /**
//     * 如果读取json失败，return true（宁可错杀，不可放过）
//     * @param simpleName 类名 class.getSimpleName()获取
//     * @return 该页面是否需要登录
//     */
//    public static boolean isNeedLogin(Context context,String simpleName){
//        String loginJson = readAssetsFile2String(context, Constant.ASSETS_FILE_NAME_NEED_LOGIN);
//        //json文件中没有配置的，都不需要登录验证
//        if(!loginJson.contains(simpleName)){
//            LogUtil.e(TAG+" isNeedLogin : current class is not contains by needLogin.json");
//            return false;
//        }
//        try {
//            JSONObject loginObj = new JSONObject(loginJson);
//            JSONArray loginArr = loginObj.getJSONArray("needLogin");
//            if(loginArr.length() > 0){
//                for(int i=0;i<loginArr.length();i++){
//                    JSONObject jsonObject = loginArr.getJSONObject(i);
//                    if(!jsonObject.has(simpleName)){
//                        continue;
//                    }
//                    return jsonObject.optBoolean(simpleName,true);
//                }
//            }else{
//                return true;
//            }
//        }catch (JSONException je){
//            je.printStackTrace();
//            return true;
//        }
//        return true;
//    }

    /**
     *
     * @param fileName assets文件夹下文件的名字
     * @return 文件的内容 String类型
     */
    public static String readAssetsFile2String(Context context,String fileName){
        StringBuilder newstringBuilder = new StringBuilder();
        InputStream inputStream = null;
        try {
            inputStream = context.getResources().getAssets().open(fileName);
            InputStreamReader isr = new InputStreamReader(inputStream);
            BufferedReader reader = new BufferedReader(isr);
            String jsonLine;
            while ((jsonLine = reader.readLine()) != null) {
                newstringBuilder.append(jsonLine);
            }
            reader.close();
            isr.close();
            inputStream.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        String result =  newstringBuilder .toString();
        LogUtil.i(TAG+" readAssetsFile2String : json : "+result);
        return result;
    }

    /**
     * 检测登录 不可用于fragment
     * @param activity Activity对象
     * @return 是否满足进入条件
     */
//    public static boolean checkLogin(Activity activity){
//        if(isNeedLogin(activity,activity.getClass().getSimpleName())
//                && !isLogin()){
//            DialogUtil.showLoginDialog(activity,true);
//            return false;
//        }else{
//            return true;
//        }
//    }
//
//    /**
//     *
//     * @return 当前是否登录
//     */
//    public static boolean isLogin(){
//        return SharedPreferencesUtil.getBooleanDate(Constant.SPKEY_IS_LOGIN);
//    }
//
//    /**
//     *
//     * @return 用户是不是合伙人
//     */
//    public static boolean isPartner(){
//        return SharedPreferencesUtil.getIntDate(Constant.SPKEY_PARTNER_STATE)==1;
//    }
//
//    /**
//     *
//     * @return 用户有没有通过认证
//     */
//    public static boolean hasCertified(){
//        return SharedPreferencesUtil.getIntDate(Constant.SPKEY_CERTIFY_STATE)==1;
//    }
//
//    /**
//     * 刷新SmartRefreshLayout状态
//     * @param refreshLayout
//     * @param hasMore 是否还有更多
//     */
//    public static void resetRefreshViewState(SmartRefreshLayout refreshLayout,boolean hasMore){
//        if(refreshLayout == null){
//            return;
//        }
//        if(refreshLayout.getState() == RefreshState.Refreshing){
//            refreshLayout.finishRefresh();
//        }else if(refreshLayout.getState() == RefreshState.Loading){
//            if(hasMore){
//                refreshLayout.finishLoadMore();
//            }else{
//                refreshLayout.finishLoadMoreWithNoMoreData();
//            }
//        }
//    }
//
//    /**
//     * 删除别名
//     * @param context 上下文
//     */
//    public static void deleteAlias(Context context){
//        JPushInterface.deleteAlias(context,SharedPreferencesUtil.getIntDate(Constant.SPKEY_USERID));
//    }
//
//    /**
//     * 设置别名
//     * @param context 上下文
//     */
//    public static void setAlias(Context context){
//        int userId = SharedPreferencesUtil.getIntDate(Constant.SPKEY_USERID);
//        JPushInterface.setAlias(context,userId,userId+"");
//    }
//
//    /**
//     * 设置沉浸式状态栏
//     */
//    public static void setDeepStatusBar(Activity activity){
//        ScreenManager.getInstance().setStatusBar(true,activity);
//    }
//
//    /**
//     * 设置沉浸式状态栏，状态栏字体为黑色
//     */
//    public static void setDarkStatusBar(Activity activity){
//        ScreenManager.getInstance().setDeepStatusBar(true,activity);
//    }

    public static final int TYPE_NO_COUPONS = 0;//无优惠券
    public static final int TYPE_NO_SEARCH_RESULT = 1;//无搜索内容
    public static final int TYPE_NO_HISTORY = 2;//无历史
    public static final int TYPE_NO_COURSEWARE = 3;//无课件
    public static final int TYPE_NO_COLLECTIONS = 4;//无收藏
    public static final int TYPE_NO_NETWORK = 5;//无网络
    public static final int TYPE_NO_MESSAGE = 6;//无消息
    public static final int TYPE_NO_COURSEWARE_IN_HOMEPAGE = 7;//首页无相关课件
    public static final int TYPE_NO_PARTNER = 8;//无合伙人
    public static final int TYPE_NO_ACCOUNT_RECORD = 9;//无账户记录

//    /**
//     * 根据类型设置空状态
//     * @param textView 空状态textView
//     */
//    public static void setEmptyState(Context context,TextView textView,int type){
//        textView.setTextColor(context.getResources().getColor(R.color.color_subtext_subtitle));
//        textView.setGravity(Gravity.CENTER);
//        switch (type){
//            case TYPE_NO_COUPONS:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_empty_state_no_coupons,0,0);
//                textView.setText(R.string.no_coupons_empty_state);
//                break;
//            case TYPE_NO_SEARCH_RESULT:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_no_search_result_empty_state,0,0);
//                textView.setText(R.string.no_search_result_empty_state);
//                break;
//            case TYPE_NO_HISTORY:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_no_history_empty_state,0,0);
//                textView.setText(R.string.no_history_empty_state);
//                break;
//            case TYPE_NO_COURSEWARE:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_no_courseware_empty_state,0,0);
//                textView.setText(R.string.no_courseware_empty_state);
//                break;
//            case TYPE_NO_COLLECTIONS:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_no_collection_empty_state,0,0);
//                textView.setText(R.string.no_collections_empty_state);
//                break;
//            case TYPE_NO_NETWORK:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_no_network_empty_state,0,0);
//                textView.setText(R.string.no_network_empty_state);
//                break;
//            case TYPE_NO_MESSAGE:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_no_message_empty_state,0,0);
//                textView.setText(R.string.no_message_empty_state);
//                break;
//            case TYPE_NO_COURSEWARE_IN_HOMEPAGE:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_no_courseware_in_homepage,0,0);
//                textView.setText(R.string.no_courseware_in_homepage_empty_state);
//                break;
//            case TYPE_NO_PARTNER:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_empty_state_no_partner,0,0);
//                textView.setText(R.string.no_partner_empty_state);
//                break;
//            case TYPE_NO_ACCOUNT_RECORD:
//                textView.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_no_history_empty_state,0,0);
//                textView.setText(R.string.no_accout_record_empty_state);
//                break;
//        }
//    }

    //获取是否存在NavigationBar
    public static boolean checkDeviceHasNavigationBar(Context context) {
        boolean hasNavigationBar = false;
        Resources rs = context.getResources();
        int id = rs.getIdentifier("config_showNavigationBar", "bool", "android");
        if (id > 0) {
            hasNavigationBar = rs.getBoolean(id);
        }
        try {
            Class systemPropertiesClass = Class.forName("android.os.SystemProperties");
            Method m = systemPropertiesClass.getMethod("get", String.class);
            String navBarOverride = (String) m.invoke(systemPropertiesClass, "qemu.hw.mainkeys");
            if ("1".equals(navBarOverride)) {
                hasNavigationBar = false;
            } else if ("0".equals(navBarOverride)) {
                hasNavigationBar = true;
            }
        } catch (Exception e) {

        }
        return hasNavigationBar;

    }

    public static int getNavigationBarHeight(Context context) {
        Resources resources = context.getResources();
        int resourceId = resources.getIdentifier("navigation_bar_height","dimen", "android");
        int height = resources.getDimensionPixelSize(resourceId);
        LogUtil.d(TAG+" NavigationBar height : "+height);
        return height;
    }

    /**
     * 拿出列表的前8个item放在另外一个列表里
     */
    public static List<String> getEightItems(List<String> oriList){
        List<String> resultList = new ArrayList<>();
        if(oriList.size() > 8){
            for(int i=0;i<8;i++){
                resultList.add(oriList.get(i));
            }
        }else{
            return oriList;
        }
        return resultList;
    }

    /**
     * 检查要加入列表的Item是否已经存在，如果存在则
     * 将列表中当前已经存在的Item放到第一位
     */
    public static List<String> checkIsItemExist(List<String> oriList,String content){
        int existPosition = -1;
        for(int i=0;i<oriList.size();i++){
            if(oriList.get(i).equals(content)){
                existPosition = i;
            }
        }
        if(existPosition > 0){
            oriList.remove(existPosition);
            oriList.add(0,content);
            return oriList;
        }else{
            return null;//代表不存在一样的内容
        }
    }

    /**
     * 判断是否高于6.0版本
     */
    public static boolean isHigherThanM(){
        if(Build.VERSION.SDK_INT >= Build.VERSION_CODES.M){
            return true;
        }
        return false;
    }

//    public static void setSpan(TextView customsEditText,boolean isBold, boolean isItalic, boolean isUnderline, boolean isStrike, boolean isHeight, String content, float fontSize,boolean isTitleType) {
//        if (TextUtils.isEmpty(content))
//            return;
//        SpannableString mSpannable = new SpannableString(content);
//        mSpannable.setSpan(new AbsoluteSizeSpan(SizeUtils.sp2px(fontSize)), 0, content.length(), Spanned.SPAN_INCLUSIVE_INCLUSIVE);//不设置字号，当前字号会被覆盖为默认字号
//        if (isBold && isItalic)
//            mSpannable.setSpan(new StyleSpan(Typeface.BOLD_ITALIC), 0, content.length(), Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//        else if (isBold && !isItalic)
//            mSpannable.setSpan(new StyleSpan(Typeface.BOLD), 0, content.length(), Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//        else if (!isBold && isItalic)
//            mSpannable.setSpan(new StyleSpan(Typeface.ITALIC), 0, content.length(), Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//
//        if (isUnderline)
//            mSpannable.setSpan(new UnderlineSpan(), 0, content.length(), Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//        if (isStrike)
//            mSpannable.setSpan(new StrikethroughSpan(), 0, content.length(), Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//        if (isHeight)
//            mSpannable.setSpan(new BackgroundColorSpan(Color.parseColor("#FFF499")), 0, content.length(), Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//        if(isTitleType){
//            customsEditText.setLineSpacing(0,2.0f);
//        }
//
//        customsEditText.setText(mSpannable);
//    }

    /**
     * 通过当前应用版本号获取CustomsEditText版本号
     */
    public static int getTextVersionCode(Context context){
//        if(APKVersionCodeUtils.getVersionCode(context) >= 5){
//            return 1;
//        }
        return 0;
    }
//
//    public static void fillEditFrameInfo(TextView textView, EditFrameInfo editFrameInfo){
//        textView.setText(editFrameInfo.getmContent(),TextView.BufferType.EDITABLE);
//        Effects effects = editFrameInfo.getEffects();
//        textView.setTextColor(effects.getTextColor());
//        textView.setTypeface(App.getApp().getTypefaceList().get(effects.getFontId()));
//        textView.setTextSize(effects.getTextSize());
//        textView.setLineSpacing(0,effects.isTitleMode()?2.0f:1.5f);
//        int length = textView.length();
//        if(effects.isBottomLine() && textView.getEditableText() != null) {
//            textView.getEditableText().setSpan(new UnderlineSpan(), 0, length, Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//        }
//        if(effects.isHighLight() && textView.getEditableText() != null) {
//            textView.getEditableText().setSpan(new BackgroundColorSpan(Color.parseColor("#FFF499")),0,length,Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//        }
//        if(effects.isMiddleLine() && textView.getEditableText() != null){
//            textView.getEditableText().setSpan(new StrikethroughSpan(), 0, length, Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//        }
//        boolean italic = effects.isItalic(),bold = effects.isBold();
//        if(textView.getEditableText() != null){
//            if(italic && !bold){
//                textView.getEditableText().setSpan(new StyleSpan(Typeface.ITALIC),0,length,Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//            }else if(!italic && bold){
//                textView.getEditableText().setSpan(new StyleSpan(Typeface.BOLD),0,length,Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//            }else if(italic && bold){
//                textView.getEditableText().setSpan(new StyleSpan(Typeface.BOLD_ITALIC),0,length,Spanned.SPAN_INCLUSIVE_INCLUSIVE);
//            }
//        }
//    }

}

